#ifndef _MEM_CARTA
#define _MEM_CARTA

#include <string>
#include "sdl.h"

namespace mem {

class Carta {
private:
    sdl::TextureArray* texture; /**< Textura con los grficos  */
    int index;                  /**< ndice del grfico en la textura */
    bool mostrar;               /**< Indica si la carta est vuelta o no */
    bool bloqueada;             /**< Carta bloqueada  */
public:
    Carta() : texture(NULL), index(0), mostrar(false) {}
    Carta(sdl::TextureArray* text, int i) : texture(text), index(i), mostrar(false), bloqueada(false) {}
    void Show(sdl::Point& p);
    void Mostrar(bool m=true) { mostrar=m; }
    void Bloquear(bool b=true) { bloqueada=b; }
    bool Bloqueada() { return bloqueada; }
    bool operator==(Carta& c) { return index==c.index; }
//int Index() { return index; }
};
}
#endif // _MEM_CARTA

