#include "sdl_button.h"

namespace sdl {

EXPORT Button::Button(Renderer& r, Point pos, TextureArray* t, int i, std::string str, Font& f, int ts, Color c) :
    renderer(r), texture(t), index(i), font(f), line(str), textsize(ts), color(c), active(false), visible(false) {
    // Calcular altura y anchura del botn en funcin de la textura y str
    int h;
    margen=8;
    font.SetSize(textsize);
    font.SetOutline(0);
    Rect textarea = font.GetArea(line);
    if(texture->H() > textarea.H()) {
        h = texture->H();
        posTexture.Y()=pos.Y()+margen;
        posText.Y()=pos.Y()+margen+(h-textarea.H())/2;
    } else {
        h = textarea.H();
        posTexture.Y()=pos.Y()+margen+(h-texture->H())/2;
        posText.Y()=pos.Y()+margen;
    }
    rect.H() = h+2*margen; // pargen pixels de margen por cada lado
    rect.W() = textarea.W()+texture->W()+3*margen; // margen pixels de margen por cada lado y 10 de separacin entre textura y texto
    posTexture.X()=pos.X()+margen;
    posText.X()=pos.X()+2*margen+texture->W();
    SetPos(pos);
}

EXPORT void Button::Render() {
    Rect re=rect;
    SDL_BlendMode blendMode;
    if(visible) {
        renderer.SetDrawColor(sdl::Color("#80808050"));
        renderer.FillRect(re);
        renderer.SetDrawColor(sdl::Color("#ffffffff"));
        renderer.DrawRect(re);
        font.SetSize(textsize);
        font.SetOutline(0);
        if(active) {
            if(texture) texture->Draw(posTexture, index);
            font.RenderUTF8_Blended(line, posText, color);
        } else {
            if(texture) {
                SDL_GetTextureBlendMode(texture->Get(), &blendMode);
                SDL_SetTextureBlendMode(texture->Get(), SDL_BLENDMODE_ADD);
                texture->Draw(posTexture, index);
                SDL_SetTextureBlendMode(texture->Get(), blendMode);
            }
            font.RenderUTF8_Blended(line, posText, Color("#ffffff40"));
        }
    }
}
EXPORT bool Button::Pushed(Point p) {
    if(active) return TestPoint(p);
     return false;
}
}
