#include "sdl_circle.h"

namespace sdl {
EXPORT FCircle FCircle::Move(float alfa, sdl::FPoint &displacement, sdl::FPoint &escale) {
    // x' = x * x" * cos(α) + y * y" * sin(α) + dx
    // y' = -x * x" * sin(α) + y * y" * cos(α) + dy
    return {escale.X()*center.X() * static_cast<float>(cos(alfa)) +
            escale.Y()*center.Y() * static_cast<float>(sin(alfa)) + escale.X()*displacement.X(),
            -escale.X()*center.X() * static_cast<float>(sin(alfa)) +
            escale.Y()*center.Y() * static_cast<float>(cos(alfa)) + escale.Y()*displacement.Y(),
            escale.X()*radius};
}
}
