#include "sdl_font.h"

namespace sdl {

EXPORT Rect Font::GetArea(const std::string& text) {
    Rect retval;
    SDL_Surface* surface = TTF_RenderUTF8_Blended(font, text.c_str(), Color("#ffffffff"));
    retval = Rect(0, 0, surface->w, surface->h);
    SDL_FreeSurface(surface);
    return retval;
}

EXPORT void Font::RenderUTF8_Blended(const std::string& text, int x, int y, Color fg) {
    SDL_Rect rText;

    SDL_Surface* surface = TTF_RenderUTF8_Blended(font, text.c_str(), fg);
    SDL_Texture* texture = SDL_CreateTextureFromSurface(renderer, surface);
    SDL_QueryTexture(texture, NULL, NULL, &rText.w, &rText.h);
    rText.x = x;
    rText.y = y;
    SDL_RenderCopy(renderer, texture, NULL, &rText);
    SDL_DestroyTexture(texture);
    SDL_FreeSurface(surface);
}
}
