#include "sdl_menu.h"

namespace sdl {
EXPORT void MenuOption::Move(Point& p) {
    line = "   ) "+cad;
    line[2] = key;
    if(selected) line[0] = '-';
    area = font.GetArea(line);
    area.X() = p.X(); area.Y() = p.Y();
}

EXPORT void MenuOption::Render(Renderer& renderer, sdl::Point& pos, sdl::Color fg) {
    Move(pos);
    font.RenderUTF8_Blended(line, pos, fg);
}

EXPORT void Menu::SetTextSize(int pt) {
    textsize=pt;
    font.SetSize(pt);
}

EXPORT void Menu::AddOption(const std::string& opt, char key, int size) {
    options.push_back(MenuOption(font, opt, key, size));
}

EXPORT void Menu::SetSel(char k) {
    for(size_t i = 0; i< options.size(); i++)
        options[i].SetSelected(options[i].Key()==k);
}

EXPORT void Menu::Clear(Color color) {
    renderer.SetDrawColor(color);
    renderer.Clear();
}
}
