#include "sdl_point.h"

namespace sdl {
EXPORT FPoint FPoint::Move(float alfa, const sdl::FPoint &displacement, const sdl::FPoint &escale) const {
        // x' = x * x" * cos(α) + y * y" * sin(α) + dx
        // y' = -x * x" * sin(α) + y * y" * cos(α) + dy
        return {
            escale.point.x*point.x * static_cast<float>(cos(alfa)) +
            escale.point.y*point.y * static_cast<float>(sin(alfa)) +
            escale.point.x*displacement.point.x,
            -escale.point.x*point.x * static_cast<float>(sin(alfa)) +
            escale.point.y*point.y * static_cast<float>(cos(alfa)) +
            escale.point.y*displacement.point.y};
    }
}
