#include "sdl_rect.h"

namespace sdl {
EXPORT FRect FRect::Move(float alfa, FPoint &displacement, FPoint &escale) {
    // x' = x * x" * cos(α) + y * y" * sin(α) + dx
    // y' = -x * x" * sin(α) + y * y" * cos(α) + dy
    return {escale.X()*rect.x * static_cast<float>(cos(alfa)) +
            escale.Y()*rect.y * static_cast<float>(sin(alfa)) + escale.X()*displacement.X(),
            -escale.X()*rect.x * static_cast<float>(sin(alfa)) +
            escale.Y()*rect.y * static_cast<float>(cos(alfa)) + escale.Y()*displacement.Y(),
            rect.w, rect.h};
}
}
