#include "sdl_texturearray.h"

namespace sdl {
EXPORT TextureArray::TextureArray(Renderer& render, const std::string file, int tileWidth, int tileHeight) :
    renderer(render), w(tileWidth), h(tileHeight) {
    int totalW, totalH;
    texture = IMG_LoadTexture(renderer, file.c_str());
    SDL_QueryTexture(texture, NULL, NULL, &totalW, &totalH);
    if(w==0 || h==0) {
        w = totalW;
        h = totalH;
    }
    cols = totalW/w;
    rows = totalH/h;
    for(int r=0; r<rows; r++) {
        for(int c=0; c<cols; c++) {
            rect.push_back(Rect(c*w, r*h, w, h));
        }
    }
}
}
